//////////////////////////////////////////////////////////
// This class has been automatically generated on
// Wed Mar 18 15:08:10 2015 by ROOT version 5.34/25
// from TTree riken_exp/experiment tree
// found on file: run1_raw.root
//////////////////////////////////////////////////////////

#ifndef Analyzer_h
#define Analyzer_h

// some may be unecessary...
#include <iostream>
#include <TStyle.h>
#include <TCanvas.h>
#include <stdio.h>
#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>
#include <TF1.h>
#include <TMath.h>
#include <TCutG.h>
#include <TGraph.h>
#include <vector>
#include <TTree.h>
using std::vector;

using namespace std;

float TimingPPAC(Float_t PpacTime[]);//function to caliculate the timing for particles to enter into PPACs
// Header file for the classes stored in the TTree if any.
void SortMax(Double_t PsdEne1a[],Double_t PsdEne1b[],Double_t PsdEne2a[],Double_t PsdEne2b[],float PsdMax[],int numMax[]);
float E_Modi(float E1st,float E2nd,int particle,int pressure,int gas);//function to modify Energy by dead layer and He between 1st layer and 2nd layer.
void Rfmodify(float rf_time_cal[],int run);//Rf shift modification
bool RfEliminate(float rf_time_cal[],int run);//elimination of strange Rf noise depending on runs  

void ExtraporateBeam(float z, float x[]);
void SetCoordinate(int numMax[], float PsdCoodinate1[]);
float cosA(float z,float PsdCoordinate1[]);
float la(float z,float PsdCoordinate1[]);
float lb(float z,float PsdCoordinate1[]);
float lc(float z,float PsdCoordinate1[]);
void PPACaCenter(float PPACaCoordinate[]);
float DistanceVsE(float Ead);
float EVsDistance(float dis);
float Ear(float Ead,float la);
float Ecmal(float z,float PsdCoordinate1[],float Ead);
float Ecmbea(float z);
void FindEcm(float PsdCoordinate1[],float Ead,float Zreaction[],float ECM[]);



class Analyzer {
public :
   TTree          *fChain;   //!pointer to the analyzed TTree or TChain
   Int_t           fCurrent; //!current Tree number in a TChain

   // Declaration of leaf types
   Float_t         rf_time[2];
   Bool_t          cr[3];
   Float_t         PPAC0_time[5];
   Float_t         PPAC0_energy[5];
   Float_t         PPAC0_AT;
   Float_t         PPAC0_x;
   Float_t         PPAC0_y;
   Float_t         PPAC1_time[5];
   Float_t         PPAC1_energy[5];
   Float_t         PPAC1_AT;
   Float_t         PPAC1_x;
   Float_t         PPAC1_y;
   Float_t         PPAC2_time[5];
   Float_t         PPAC2_energy[5];
   Float_t         PPAC2_AT;
   Float_t         PPAC2_x;
   Float_t         PPAC2_y;
   Float_t         PSD0_time[32];
   Float_t         PSD0_energy[32];
   UShort_t        PSD0_ChF;
   UShort_t        PSD0_ChB;
   Float_t         PSD0_MaxE;
   UShort_t        PSD0_EmapCh[32];
   UShort_t        PSD0_TmapCh[32];
   Float_t         PSD1_time[32];
   Float_t         PSD1_energy[32];
   UShort_t        PSD1_ChF;
   UShort_t        PSD1_ChB;
   Float_t         PSD1_MaxE;
   UShort_t        PSD1_EmapCh[32];
   UShort_t        PSD1_TmapCh[32];
   Float_t         SSD0_time;
   Float_t         SSD0_energy;
   Float_t         SSD1_time;
   Float_t         SSD1_energy;
   Float_t         SSD2_time;
   Float_t         SSD2_energy;

// analysis part (not in raw data tree)

   Bool_t 	   PpacIsHit0;
   Bool_t 	   PpacIsHit1;
      Double_t TargetX, TargetY;
      TF1 *fTargetX ;
      TF1 *fTargetY ;

	Double_t			PSD0_X_Sum;
	Double_t			PSD1_X_Sum;
	Double_t			PSD0_X_Calib[16];
	Double_t			PSD0_Y_Calib[16];
	Double_t			PSD1_X_Calib[16];
	Double_t			PSD1_Y_Calib[16];

	Double_t			PSD0_X_CalT[16];
	Double_t			PSD0_Y_CalT[16];
	Double_t			PSD1_X_CalT[16];
	Double_t			PSD1_Y_CalT[16];

	Double_t			SSD_F2_Calib[2];
	Double_t			Lowgain_Calib[2];


   // List of branches
   TBranch        *b_rf_time;   //!
   TBranch        *b_cr;   //!
   TBranch        *b_PPAC0_time;   //!
   TBranch        *b_PPAC0_energy;   //!
   TBranch        *b_PPAC0_AT;   //!
   TBranch        *b_PPAC0_x;   //!
   TBranch        *b_PPAC0_y;   //!
   TBranch        *b_PPAC1_time;   //!
   TBranch        *b_PPAC1_energy;   //!
   TBranch        *b_PPAC1_AT;   //!
   TBranch        *b_PPAC1_x;   //!
   TBranch        *b_PPAC1_y;   //!
   TBranch        *b_PPAC2_time;   //!
   TBranch        *b_PPAC2_energy;   //!
   TBranch        *b_PPAC2_AT;   //!
   TBranch        *b_PPAC2_x;   //!
   TBranch        *b_PPAC2_y;   //!
   TBranch        *b_PSD0_time;   //!
   TBranch        *b_PSD0_energy;   //!
   TBranch        *b_PSD0_ChF;   //!
   TBranch        *b_PSD0_ChB;   //!
   TBranch        *b_PSD0_MaxE;   //!
   TBranch        *b_PSD0_EmapCh;   //!
   TBranch        *b_PSD0_TmapCh;   //!
   TBranch        *b_PSD1_time;   //!
   TBranch        *b_PSD1_energy;   //!
   TBranch        *b_PSD1_ChF;   //!
   TBranch        *b_PSD1_ChB;   //!
   TBranch        *b_PSD1_MaxE;   //!
   TBranch        *b_PSD1_EmapCh;   //!
   TBranch        *b_PSD1_TmapCh;   //!
   TBranch        *b_SSD0_time;   //!
   TBranch        *b_SSD0_energy;   //!
   TBranch        *b_SSD1_time;   //!
   TBranch        *b_SSD1_energy;   //!
   TBranch        *b_SSD2_time;   //!
   TBranch        *b_SSD2_energy;   //!

   Analyzer(TChain *tree=0);
   //Analyzer(TTree *tree=0);
   virtual ~Analyzer();
   virtual Int_t    Cut(Long64_t entry);
   virtual Int_t    GetEntry(Long64_t entry);
   virtual Long64_t LoadTree(Long64_t entry);
//   virtual void     Init(TTree *tree);
   void Init(TChain *tree);
   virtual UShort_t SetPpacSepZ();
   virtual Bool_t WindowCut(Double_t x=99., Double_t y=99.);
   virtual void     Loop(Int_t run=0,
     Bool_t flag_raw=0, Bool_t flag_detail=0,
     Bool_t flag_ssd=0, Bool_t flag_ppac=0);
   virtual Bool_t   Notify();
   virtual void     Show(Long64_t entry = -1);

	



};

#endif

#ifdef Analyzer_cxx
Analyzer::Analyzer(TChain *tree) : fChain(0) 
{
// if parameter tree is not specified (or zero), connect the file
// used to generate this class and read the Tree.

// if parameter tree is not specified (or zero), exit 
   if (tree == 0) {
     return;
   }
   Init(tree);


/*
   if (tree == 0) {
      TFile *f = (TFile*)gROOT->GetListOfFiles()->FindObject("root/run19_raw.root");
      if (!f || !f->IsOpen()) {
         f = new TFile("root/run19_raw.root");
      }
      f->GetObject("riken_exp",tree);

   }
   Init(tree);
*/
}

Analyzer::~Analyzer()
{
   if (!fChain) return;
   delete fChain->GetCurrentFile();
}

Int_t Analyzer::GetEntry(Long64_t entry)
{
// Read contents of entry.
   if (!fChain) return 0;
   return fChain->GetEntry(entry);
}
Long64_t Analyzer::LoadTree(Long64_t entry)
{
// Set the environment to read one entry
   if (!fChain) return -5;
   Long64_t centry = fChain->LoadTree(entry);
   if (centry < 0) return centry;
   if (fChain->GetTreeNumber() != fCurrent) {
      fCurrent = fChain->GetTreeNumber();
      Notify();
   }
   return centry;
}

void Analyzer::Init(TChain *tree)
{
   // The Init() function is called when the selector needs to initialize
   // a new tree or chain. Typically here the branch addresses and branch
   // pointers of the tree will be set.
   // It is normally not necessary to make changes to the generated
   // code, but the routine can be extended by the user if needed.
   // Init() will be called many times when running on PROOF
   // (once per file to be processed).

   // Set branch addresses and branch pointers
   if (!tree) return;
   fChain = tree;
   fCurrent = -1;
   fChain->SetMakeClass(1);

   fChain->SetBranchAddress("rf.time", rf_time, &b_rf_time);
   fChain->SetBranchAddress("cr", cr, &b_cr);
   fChain->SetBranchAddress("PPAC0.time", PPAC0_time, &b_PPAC0_time);
   fChain->SetBranchAddress("PPAC0.energy", PPAC0_energy, &b_PPAC0_energy);
   fChain->SetBranchAddress("PPAC0.AT", &PPAC0_AT, &b_PPAC0_AT);
   fChain->SetBranchAddress("PPAC0.x", &PPAC0_x, &b_PPAC0_x);
   fChain->SetBranchAddress("PPAC0.y", &PPAC0_y, &b_PPAC0_y);
   fChain->SetBranchAddress("PPAC1.time", PPAC1_time, &b_PPAC1_time);
   fChain->SetBranchAddress("PPAC1.energy", PPAC1_energy, &b_PPAC1_energy);
   fChain->SetBranchAddress("PPAC1.AT", &PPAC1_AT, &b_PPAC1_AT);
   fChain->SetBranchAddress("PPAC1.x", &PPAC1_x, &b_PPAC1_x);
   fChain->SetBranchAddress("PPAC1.y", &PPAC1_y, &b_PPAC1_y);
   fChain->SetBranchAddress("PPAC2.time", PPAC2_time, &b_PPAC2_time);
   fChain->SetBranchAddress("PPAC2.energy", PPAC2_energy, &b_PPAC2_energy);
   fChain->SetBranchAddress("PPAC2.AT", &PPAC2_AT, &b_PPAC2_AT);
   fChain->SetBranchAddress("PPAC2.x", &PPAC2_x, &b_PPAC2_x);
   fChain->SetBranchAddress("PPAC2.y", &PPAC2_y, &b_PPAC2_y);
   fChain->SetBranchAddress("PSD0.time", PSD0_time, &b_PSD0_time);
   fChain->SetBranchAddress("PSD0.energy", PSD0_energy, &b_PSD0_energy);
   fChain->SetBranchAddress("PSD0.ChF", &PSD0_ChF, &b_PSD0_ChF);
   fChain->SetBranchAddress("PSD0.ChB", &PSD0_ChB, &b_PSD0_ChB);
   fChain->SetBranchAddress("PSD0.MaxE", &PSD0_MaxE, &b_PSD0_MaxE);
   fChain->SetBranchAddress("PSD0.EmapCh", PSD0_EmapCh, &b_PSD0_EmapCh);
   fChain->SetBranchAddress("PSD0.TmapCh", PSD0_TmapCh, &b_PSD0_TmapCh);
   fChain->SetBranchAddress("PSD1.time", PSD1_time, &b_PSD1_time);
   fChain->SetBranchAddress("PSD1.energy", PSD1_energy, &b_PSD1_energy);
   fChain->SetBranchAddress("PSD1.ChF", &PSD1_ChF, &b_PSD1_ChF);
   fChain->SetBranchAddress("PSD1.ChB", &PSD1_ChB, &b_PSD1_ChB);
   fChain->SetBranchAddress("PSD1.MaxE", &PSD1_MaxE, &b_PSD1_MaxE);
   fChain->SetBranchAddress("PSD1.EmapCh", PSD1_EmapCh, &b_PSD1_EmapCh);
   fChain->SetBranchAddress("PSD1.TmapCh", PSD1_TmapCh, &b_PSD1_TmapCh);
   fChain->SetBranchAddress("SSD0.time", &SSD0_time, &b_SSD0_time);
   fChain->SetBranchAddress("SSD0.energy", &SSD0_energy, &b_SSD0_energy);
   fChain->SetBranchAddress("SSD1.time", &SSD1_time, &b_SSD1_time);
   fChain->SetBranchAddress("SSD1.energy", &SSD1_energy, &b_SSD1_energy);
   fChain->SetBranchAddress("SSD2.time", &SSD2_time, &b_SSD2_time);
   fChain->SetBranchAddress("SSD2.energy", &SSD2_energy, &b_SSD2_energy);
   Notify();
}

Bool_t Analyzer::Notify()
{
   // The Notify() function is called when a new file is opened. This
   // can be either for a new TTree in a TChain or when when a new TTree
   // is started when using PROOF. It is normally not necessary to make changes
   // to the generated code, but the routine can be extended by the
   // user if needed. The return value is currently not used.

   return kTRUE;
}

void Analyzer::Show(Long64_t entry)
{
// Print contents of entry.
// If entry is not specified, print current entry
   if (!fChain) return;
   fChain->Show(entry);
}
Int_t Analyzer::Cut(Long64_t entry)
{
// This function may be called from Loop.
// returns  1 if entry is accepted.
// returns -1 otherwise.
   return 1;
}

#endif // #ifdef Analyzer_cxx
